;
;Instant Text Automator
;Author:		Desi Quintans <me@desiquintans.com>
;Website:		http://www.desiquintans.com
;
;Script Function:
;	This script lets you quickly write and use macros based on Autohotkey's Send command
;	in less time than it would take to write a new script for the same purpose. Write your
;	Send keystrokes (excluding the initial 'Send ' call) in a text box, then press the
;	hotkey associated with that text box to automatically output those keystrokes to your
;	active window at your cursor position. You can also adjust the Sleep time between Send
;	calls, or unmap the hotkeys by unchecking the 'Enable Hotkeys' checkbox.
;	Refer to http://www.autohotkey.com/docs/commands/Send.htm for how to use Send.
;

#NoEnv
#NoTrayIcon
CoordMode, Mouse, Screen
SendMode Input
SetWorkingDir %A_ScriptDir%
SetTitleMatchMode, 3
presentMouseX = 0
presentMouseY = 0

Gui +LastFound +OwnDialogs
GUI1 := WinExist()

Gui -MaximizeBox
	Gui, color, B0C4DE
	
	Gui, Add, GroupBox, w900 h100 Section,

		Gui, Add, Text, xs+12 ys+18 w885 +Center, Press Alt+Shift+F12 to insert the mouse cursor's screen position. {Wait n} to add an n millisecond delay. <// begins a comment line.

		Gui, Add, Checkbox, xs+125 yp+40 +Checked vENABLED gSetKeys, Enable Hotkeys
		Gui, Add, Checkbox, xp+140 yp vREPLACE gUpdateGuiVars, Replace Mouse
		
		Gui, Add, Edit, xp+140 yp-10 w80 h20 +Center +Number vSLEEPTIME gUpdateGuiVars, 10
		Gui, Add, Text, xp yp+25 w80 h20 +Center, Line Delay (ms)
		
		Gui, Add, Button, xp+140 yp-25 w90 h30 gSave, Save Profile
		Gui, Add, Button, xp+140 yp w90 h30 gOpen, Load Profile
	
		Gui, Add, Button, xs+12 ys+18 w20 h20 gInfo, ?

	; Row 1

	Gui, Add, GroupBox, xm ys+120 w290 h150 Section, Bound to:
		Gui, Add, Hotkey, xs+57 ys-3 w90 r1 vBIND1 gSetKeys
		Gui, Add, Edit, xs+12 ys+30 w265 h107 vBINDTEXT1 gUpdateGuiVars,
	
	Gui, Add, GroupBox, xs+305 ys w290 h150 Section, Bound to:
		Gui, Add, Hotkey, xs+57 ys-3 w90 r1 vBIND2 gSetKeys
		Gui, Add, Edit, xs+12 ys+30 w265 h107 vBINDTEXT2 gUpdateGuiVars,
	
	Gui, Add, GroupBox, xs+305 ys w290 h150 Section, Bound to:
		Gui, Add, Hotkey, xs+57 ys-3 w90 r1 vBIND3 gSetKeys
		Gui, Add, Edit, xs+12 ys+30 w265 h107 vBINDTEXT3 gUpdateGuiVars,
		
	; Row 2
	
	Gui, Add, GroupBox, xm ys+170 w290 h150 Section, Bound to:
		Gui, Add, Hotkey, xs+57 ys-3 w90 r1 vBIND4 gSetKeys
		Gui, Add, Edit, xs+12 ys+30 w265 h107 vBINDTEXT4 gUpdateGuiVars,
	
	Gui, Add, GroupBox, xs+305 ys w290 h150 Section, Bound to:
		Gui, Add, Hotkey, xs+57 ys-3 w90 r1 vBIND5 gSetKeys
		Gui, Add, Edit, xs+12 ys+30 w265 h107 vBINDTEXT5 gUpdateGuiVars,
	
	Gui, Add, GroupBox, xs+305 ys w290 h150 Section, Bound to:
		Gui, Add, Hotkey, xs+57 ys-3 w90 r1 vBIND6 gSetKeys
		Gui, Add, Edit, xs+12 ys+30 w265 h107 vBINDTEXT6 gUpdateGuiVars,
	
	; Row 3
	
	Gui, Add, GroupBox, xm ys+170 w290 h150 Section, Bound to:
		Gui, Add, Hotkey, xs+57 ys-3 w90 r1 vBIND7 gSetKeys
		Gui, Add, Edit, xs+12 ys+30 w265 h107 vBINDTEXT7 gUpdateGuiVars,
	
	Gui, Add, GroupBox, xs+305 ys w290 h150 Section, Bound to:
		Gui, Add, Hotkey, xs+57 ys-3 w90 r1 vBIND8 gSetKeys
		Gui, Add, Edit, xs+12 ys+30 w265 h107 vBINDTEXT8 gUpdateGuiVars,
	
	Gui, Add, GroupBox, xs+305 ys w290 h150 Section, Bound to:
		Gui, Add, Hotkey, xs+57 ys-3 w90 r1 vBIND9 gSetKeys
		Gui, Add, Edit, xs+12 ys+30 w265 h107 vBINDTEXT9 gUpdateGuiVars,
	
	Gui, Add, Text, xm ys+160 w900 +Center, v9, 29 June 2013`ndesiquintans.com/automator
	
	Gui, Show, Autosize, Instant Text Automator
	GoSub, SetKeys
	ControlFocus, Edit2

OnMessage(0x200, "Help")
OnMessage(0x53, "WM_HELP")

UpdateGuiVars:
	Gui, Submit, NoHide
return

Info:
	RunWait http://www.autohotkey.com/docs/commands/Send.htm
return

SetKeys:
	Gui, Submit, NoHide
	if ENABLED = 1
	{
		Hotkey,%BIND1_old%,DoBind1,off UseErrorLevel
		Hotkey,%BIND1%,DoBind1,on UseErrorLevel
		BIND1_old:=BIND1
		
		Hotkey,%BIND2_old%,DoBind2,off UseErrorLevel
		Hotkey,%BIND2%,DoBind2,on UseErrorLevel
		BIND2_old:=BIND2
		
		Hotkey,%BIND3_old%,DoBind3,off UseErrorLevel
		Hotkey,%BIND3%,DoBind3,on UseErrorLevel
		BIND3_old:=BIND3
		
		Hotkey,%BIND4_old%,DoBind4,off UseErrorLevel
		Hotkey,%BIND4%,DoBind4,on UseErrorLevel
		BIND4_old:=BIND4
		
		Hotkey,%BIND5_old%,DoBind5,off UseErrorLevel
		Hotkey,%BIND5%,DoBind5,on UseErrorLevel
		BIND5_old:=BIND5
		
		Hotkey,%BIND6_old%,DoBind6,off UseErrorLevel
		Hotkey,%BIND6%,DoBind6,on UseErrorLevel
		BIND6_old:=BIND6
		
		Hotkey,%BIND7_old%,DoBind7,off UseErrorLevel
		Hotkey,%BIND7%,DoBind7,on UseErrorLevel
		BIND7_old:=BIND7
		
		Hotkey,%BIND8_old%,DoBind8,off UseErrorLevel
		Hotkey,%BIND8%,DoBind8,on UseErrorLevel
		BIND8_old:=BIND8
		
		Hotkey,%BIND9_old%,DoBind9,off UseErrorLevel
		Hotkey,%BIND9%,DoBind9,on UseErrorLevel
		BIND9_old:=BIND9
	}
	else
	{
		Hotkey,%BIND1%,DoBind1,off UseErrorLevel
		Hotkey,%BIND2%,DoBind2,off UseErrorLevel
		Hotkey,%BIND3%,DoBind3,off UseErrorLevel
		Hotkey,%BIND4%,DoBind4,off UseErrorLevel
		Hotkey,%BIND5%,DoBind5,off UseErrorLevel
		Hotkey,%BIND6%,DoBind6,off UseErrorLevel
		Hotkey,%BIND7%,DoBind7,off UseErrorLevel
		Hotkey,%BIND8%,DoBind8,off UseErrorLevel
		Hotkey,%BIND9%,DoBind9,off UseErrorLevel
	}
Return

DoBind(MacroBox)
{
	global REPLACE
	if REPLACE = 1
	{
		MouseGetPos, presentMouseX, presentMouseY
	}
	
	Loop, parse, MacroBox, `n, `r
	{
		; Commenting tag is <// Blahblahblah. Must occur at the start of a line.
		if RegExMatch(A_LoopField, "^<//") = 0
		{
		    Send %A_LoopField%
		    
		    ; Custom pause tag is {Wait NUMBER} at any part of a line. It is automatically
		    ; ignored by AHK if it occurs within a macro's text. The pause is applied only
		    ; at the end of the line it is found on.
			if RegExMatch(A_LoopField, "i)\{\s?Wait\s?([0-9]*)\s?\}", PlusDelay) != 0
			{
				Sleep, PlusDelay1
			}
			else
			{
				Sleep, SLEEPTIME
			}
		}
	}
	
	if REPLACE = 1
	{
		Send, {Click %presentMouseX%, %presentMouseY% 0}
	}
}

; The Hotkey command only accepts labels as an input, so I have to call DoBind() in these
; labels rather than just directly calling DoBind() from the Hotkey commands.

DoBind1:
	DoBind(BINDTEXT1)
return

DoBind2:
	DoBind(BINDTEXT2)
return

DoBind3:
	DoBind(BINDTEXT3)
return

DoBind4:
	DoBind(BINDTEXT4)
return

DoBind5:
	DoBind(BINDTEXT5)
return

DoBind6:
	DoBind(BINDTEXT6)
return

DoBind7:
	DoBind(BINDTEXT7)
return

DoBind8:
	DoBind(BINDTEXT8)
return

DoBind9:
	DoBind(BINDTEXT9)
return

Open:
	FileSelectFile, openfilename,3,,Load a profile - Instant Text Automator, Configuration file (*.ini)
	if ErrorLevel = 0
	{
		if openfilename != ""
		{
			IniRead, newREPLACE, %openfilename%, General, ReplaceMouse, 0
				GuiControl,, REPLACE, %newReplace%
				
			IniRead, newSLEEPTIME, %openfilename%, General, SleepTime, 10
				GuiControl,, SLEEPTIME, %newSLEEPTIME%
		
			IniRead, newBIND1, %openfilename%, Set1, Shortcut, %A_SPACE%
			IniRead, newBIND2, %openfilename%, Set2, Shortcut, %A_SPACE%
			IniRead, newBIND3, %openfilename%, Set3, Shortcut, %A_SPACE%
			IniRead, newBIND4, %openfilename%, Set4, Shortcut, %A_SPACE%
			IniRead, newBIND5, %openfilename%, Set5, Shortcut, %A_SPACE%
			IniRead, newBIND6, %openfilename%, Set6, Shortcut, %A_SPACE%
			IniRead, newBIND7, %openfilename%, Set7, Shortcut, %A_SPACE%
			IniRead, newBIND8, %openfilename%, Set8, Shortcut, %A_SPACE%
			IniRead, newBIND9, %openfilename%, Set9, Shortcut, %A_SPACE%
			
				GuiControl,, BIND1, %newBIND1%
				GuiControl,, BIND2, %newBIND2%
				GuiControl,, BIND3, %newBIND3%
				GuiControl,, BIND4, %newBIND4%
				GuiControl,, BIND5, %newBIND5%
				GuiControl,, BIND6, %newBIND6%
				GuiControl,, BIND7, %newBIND7%
				GuiControl,, BIND8, %newBIND8%
				GuiControl,, BIND9, %newBIND9%
		
			IniRead, newBINDTEXT1, %openfilename%, Set1, Command, %A_Space%
			IniRead, newBINDTEXT2, %openfilename%, Set2, Command, %A_Space%
			IniRead, newBINDTEXT3, %openfilename%, Set3, Command, %A_Space%
			IniRead, newBINDTEXT4, %openfilename%, Set4, Command, %A_Space%
			IniRead, newBINDTEXT5, %openfilename%, Set5, Command, %A_Space%
			IniRead, newBINDTEXT6, %openfilename%, Set6, Command, %A_Space%
			IniRead, newBINDTEXT7, %openfilename%, Set7, Command, %A_Space%
			IniRead, newBINDTEXT8, %openfilename%, Set8, Command, %A_Space%
			IniRead, newBINDTEXT9, %openfilename%, Set9, Command, %A_Space%
	
				StringReplace, newBINDTEXT1, newBINDTEXT1, <````n>, `n, All
				StringReplace, newBINDTEXT2, newBINDTEXT2, <````n>, `n, All
				StringReplace, newBINDTEXT3, newBINDTEXT3, <````n>, `n, All
				StringReplace, newBINDTEXT4, newBINDTEXT4, <````n>, `n, All
				StringReplace, newBINDTEXT5, newBINDTEXT5, <````n>, `n, All
				StringReplace, newBINDTEXT6, newBINDTEXT6, <````n>, `n, All
				StringReplace, newBINDTEXT7, newBINDTEXT7, <````n>, `n, All
				StringReplace, newBINDTEXT8, newBINDTEXT8, <````n>, `n, All
				StringReplace, newBINDTEXT9, newBINDTEXT9, <````n>, `n, All
	
				StringReplace, newBINDTEXT1, newBINDTEXT1, <````'>, ', All
				StringReplace, newBINDTEXT2, newBINDTEXT2, <````'>, ', All
				StringReplace, newBINDTEXT3, newBINDTEXT3, <````'>, ', All
				StringReplace, newBINDTEXT4, newBINDTEXT4, <````'>, ', All
				StringReplace, newBINDTEXT5, newBINDTEXT5, <````'>, ', All
				StringReplace, newBINDTEXT6, newBINDTEXT6, <````'>, ', All
				StringReplace, newBINDTEXT7, newBINDTEXT7, <````'>, ', All
				StringReplace, newBINDTEXT8, newBINDTEXT8, <````'>, ', All
				StringReplace, newBINDTEXT9, newBINDTEXT9, <````'>, ', All
	
				GuiControl,, BINDTEXT1, %newBINDTEXT1%
				GuiControl,, BINDTEXT2, %newBINDTEXT2%
				GuiControl,, BINDTEXT3, %newBINDTEXT3%
				GuiControl,, BINDTEXT4, %newBINDTEXT4%
				GuiControl,, BINDTEXT5, %newBINDTEXT5%
				GuiControl,, BINDTEXT6, %newBINDTEXT6%
				GuiControl,, BINDTEXT7, %newBINDTEXT7%
				GuiControl,, BINDTEXT8, %newBINDTEXT8%
				GuiControl,, BINDTEXT9, %newBINDTEXT9%
	
			GoSub, UpdateGuiVars
			GoSub, SetKeys
		}
	}
return

Save:
	FileSelectFile, savefilename, S24, %A_WorkingDir%\%A_DD% %A_MMM% %A_YYYY% %A_Hour%%A_Min%.ini, Save your profile - Instant Text Automator, Configuration file (*.ini)
	
	if ErrorLevel = 0
	{
		if savefilename != ""
		{
			if RegExMatch(savefilename, "(.ini)$") = 0
			{
				savefilename = %savefilename%.ini
			}
			FileDelete, %savefilename%
			
			IniWrite, %REPLACE%, %savefilename%, General, ReplaceMouse
			IniWrite, %SLEEPTIME%, %savefilename%, General, SleepTime
			
			IniWrite, %BIND1%, %savefilename%, Set1, Shortcut
			IniWrite, %BIND2%, %savefilename%, Set2, Shortcut
			IniWrite, %BIND3%, %savefilename%, Set3, Shortcut
			IniWrite, %BIND4%, %savefilename%, Set4, Shortcut
			IniWrite, %BIND5%, %savefilename%, Set5, Shortcut
			IniWrite, %BIND6%, %savefilename%, Set6, Shortcut
			IniWrite, %BIND7%, %savefilename%, Set7, Shortcut
			IniWrite, %BIND8%, %savefilename%, Set8, Shortcut
			IniWrite, %BIND9%, %savefilename%, Set9, Shortcut
			
			
			
			StringReplace, encodedBINDTEXT1, BINDTEXT1, `n, <````n>, All
			StringReplace, encodedBINDTEXT2, BINDTEXT2, `n, <````n>, All
			StringReplace, encodedBINDTEXT3, BINDTEXT3, `n, <````n>, All
			StringReplace, encodedBINDTEXT4, BINDTEXT4, `n, <````n>, All
			StringReplace, encodedBINDTEXT5, BINDTEXT5, `n, <````n>, All
			StringReplace, encodedBINDTEXT6, BINDTEXT6, `n, <````n>, All
			StringReplace, encodedBINDTEXT7, BINDTEXT7, `n, <````n>, All
			StringReplace, encodedBINDTEXT8, BINDTEXT8, `n, <````n>, All
			StringReplace, encodedBINDTEXT9, BINDTEXT9, `n, <````n>, All

			StringReplace, encodedBINDTEXT1, encodedBINDTEXT1, ', <````'>, All
			StringReplace, encodedBINDTEXT2, encodedBINDTEXT2, ', <````'>, All
			StringReplace, encodedBINDTEXT3, encodedBINDTEXT3, ', <````'>, All
			StringReplace, encodedBINDTEXT4, encodedBINDTEXT4, ', <````'>, All
			StringReplace, encodedBINDTEXT5, encodedBINDTEXT5, ', <````'>, All
			StringReplace, encodedBINDTEXT6, encodedBINDTEXT6, ', <````'>, All
			StringReplace, encodedBINDTEXT7, encodedBINDTEXT7, ', <````'>, All
			StringReplace, encodedBINDTEXT8, encodedBINDTEXT8, ', <````'>, All
			StringReplace, encodedBINDTEXT9, encodedBINDTEXT9, ', <````'>, All
			
			IniWrite, %encodedBINDTEXT1%, %savefilename%, Set1, Command
			IniWrite, %encodedBINDTEXT2%, %savefilename%, Set2, Command
			IniWrite, %encodedBINDTEXT3%, %savefilename%, Set3, Command
			IniWrite, %encodedBINDTEXT4%, %savefilename%, Set4, Command
			IniWrite, %encodedBINDTEXT5%, %savefilename%, Set5, Command
			IniWrite, %encodedBINDTEXT6%, %savefilename%, Set6, Command
			IniWrite, %encodedBINDTEXT7%, %savefilename%, Set7, Command
			IniWrite, %encodedBINDTEXT8%, %savefilename%, Set8, Command
			IniWrite, %encodedBINDTEXT9%, %savefilename%, Set9, Command
		}
	}
return

!+F12::
	MouseGetPos, mouseX, mouseY
	WinActivate, Instant Text Automator
		; Nested brackets are for printing { and } characters as plain text.
	Send {{}Click %mouseX%, %mouseY%{}}
return

; This tooltip code is from Alpha Bravo, http://www.autohotkey.com/board/topic/81915-solved-gui-control-tooltip-on-hover/#entry520741
Help(wParam, lParam, Msg)
{
	MouseGetPos,,,, OutputVarControl
	
	IfEqual, OutputVarControl, Button2
		Help := "Enable or disable all hotkeys without unbinding them."
		
	else IfEqual, OutputVarControl, Button3
		Help := "Put the mouse cursor back in its original position when the macro is finished."
		
	else IfEqual, OutputVarControl, Edit1
		Help := "How many milliseconds to wait before running the next line in the macro."
		
	else IfEqual, OutputVarControl, Static2
		Help := "How many milliseconds to wait before running the next line in the macro."
		
	else IfEqual, OutputVarControl, Button4
		Help := "Save this panel of macros for later use."
		
	else IfEqual, OutputVarControl, Button5
		Help := "Load a previously-saved panel of macros."
		
	else IfEqual, OutputVarControl, Button6
		Help := "Open the Send command reference page (autohotkey.com)."
	
	ToolTip % Help
}

GuiClose:
ExitApp